/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingTipoPtoVtaDAO;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingTipoPtoVta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.PricingTipoPtoVtaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("pricingTipoPtoVtaService")
public class PricingTipoPtoVtaServiceImpl implements PricingTipoPtoVtaService {

    @Autowired
    private PricingTipoPtoVtaDAO pricingTipoPtoVtaDAO;

    public List<PricingTipoPtoVta> obtenerTodos() {
        return pricingTipoPtoVtaDAO.obtenerTodos();
    }

    public PricingTipoPtoVta obtenerID(Integer id) {
        return pricingTipoPtoVtaDAO.obtenerID(id);
    }

    @Transactional
    public PricingTipoPtoVta suscribir(PricingTipoPtoVta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.ATIVO);

        return pricingTipoPtoVtaDAO.suscribir(entidad);
    }

    @Transactional
    public PricingTipoPtoVta actualizacion(PricingTipoPtoVta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.ATIVO);

        return pricingTipoPtoVtaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PricingTipoPtoVta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Pricing.EXCLUIDO);

        pricingTipoPtoVtaDAO.actualizacion(entidad);
    }

    public Boolean obtenerPricingTipoPuntoVenta(Pricing pricing, TipoPuntoVenta tipoPuntoVenta) {
        return pricingTipoPtoVtaDAO.obtenerPricingTipoPuntoVenta(pricing, tipoPuntoVenta);
    }

	@Override
	@Transactional
	public void borrar(List<PricingTipoPtoVta> pricingTipoPtoVtas) {
		if(pricingTipoPtoVtas != null && !pricingTipoPtoVtas.isEmpty()) {
			for (PricingTipoPtoVta pricingTipoPtoVta : pricingTipoPtoVtas) {
				borrar(pricingTipoPtoVta);
			}
		}
	}
}
